function changeRange(name, value, originalValue) {
    var el = document.getElementsByName(name)[0];
    var max = el.getAttribute('max');
    if (value > max)
        value = max;
    if (originalValue > max)
        originalValue = max;
    el.value = value;
    if (typeof (originalValue) != 'undefined') {
        el.setAttribute('original-value', originalValue);
    }
    $("[name=" + name + "]").trigger('change');
}

function absRangeValue(name) {
    return document.getElementsByName(name)[0].value;
}

function getRangeValue(el, previous) {
    var value = el.value;
    if ($(el).attr('normalise') == '1') {
        value -= $(el).attr('min');
    }
    value *= $(el).attr('ratio');

    if (typeof ($(el).attr('less-than')) != 'undefined') {
        if ($(el).attr('less-than') != previous) {
            var maxValue = getRangeValue(document.getElementsByName($(el).attr('less-than'))[0], $(el).attr('name'));
            var oldValue = value;
            value = Math.min(value, maxValue);
            if (oldValue != value)
                el.value = value;
        }
    }

    if (typeof ($(el).attr('more-than')) != 'undefined') {
        if ($(el).attr('more-than') != previous) {
            var minValue = getRangeValue(document.getElementsByName($(el).attr('more-than'))[0], $(el).attr('name'));
            var oldValue = value;
            value = Math.max(value, minValue);
            if (oldValue != value)
                el.value = value;
        }
    }

    var originalValue = getOriginalValue(el);
    if (typeof (originalValue) != 'undefined' && originalValue != null) {
        var oldValue = value;
        value = Math.max(value, originalValue);
        if (oldValue != value)
            el.value = value;
    }

    return value;
}

function getOriginalValue(el) {
    var original = el.getAttribute('original-value');
    return original;
}

function pollRangers() {
    $("[type=range]").on("change input", function () {
        var value = getRangeValue(this, null);
        var original = getOriginalValue(this);
        var adjust = '';

        if (typeof (original) != 'undefined' && original != null) {
            var ratio = $(this).attr('ratio');
            var diff = value / ratio - original;
            if (diff != 0) {
                adjust = "&nbsp;<font color='red'><b>(" + (diff < 0 ? '-' : diff > 0 ? '+' : '') + Math.abs(diff) + ")</b></font>";
            }
        }

        $("[for=" + $(this).attr('name') + "]").html(Math.floor(value) + $(this).attr('unit') + adjust);

        var callback = $(this).attr('callback');

        if (typeof (callback) != 'undefined') {
            eval(callback + '(\"' + $(this).attr('id') + '\");');
        }

        var link = $(this).attr('link');

        if (typeof (link) != 'undefined') {
            var links = link.split(',');
            for (var i = 0; i < links.length; i++) {
                $("#" + links[i]).trigger("change");
            }
        }
    }).trigger("change");
}
